﻿using System;
using System.Data;
using System.ComponentModel;
using System.Configuration;
using System.Security.Permissions;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;

namespace ch5
{
    [
        AspNetHostingPermission(SecurityAction.Demand,
            Level = AspNetHostingPermissionLevel.Minimal),
        AspNetHostingPermission(SecurityAction.InheritanceDemand,
            Level = AspNetHostingPermissionLevel.Minimal),
        DefaultProperty("Text"),
        ToolboxData("<{0}:EventButton runat=\"server\"> </{0}:EventButton>")
    ]
    /// <summary>
    /// EventButtonClass の概要の説明です
    /// </summary>
    public class EventButton : Button, ICallbackEventHandler
    {
        public class XmlEventArgs : EventArgs
        {
            XmlDocument document;
            string result;
            public XmlEventArgs(XmlDocument doc)
            {
                document = doc;
            }
            public XmlDocument Document
            {
                get { return document; }
            }
            public string Result
            {
                get { return result; }
                set { result = value; }
            }
        }

        public EventButton()
        {
            //
            // TODO: コンストラクタ ロジックをここに追加します
            //
        }

        string resultValue;

        #region ICallbackEventHandler メンバ

        public string GetCallbackResult()
        {
            return resultValue;
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(eventArgument);
            XmlEventArgs arg = new XmlEventArgs(doc);
            OnClick(arg);
            resultValue = arg.Result;
        }

        #endregion
    }
}
